"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : new P(function (resolve) { resolve(result.value); }).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var path = __importStar(require("path"));
var escodegen = __importStar(require("escodegen"));
var acorn = __importStar(require("acorn"));
var source_map_1 = require("source-map");
var translate_visitor_1 = __importDefault(require("./translate-visitor"));
var loaderUtils = __importStar(require("loader-utils"));
/**
 * Webpack loader that extracts translations from calls to the angular-translate $translate service.
 * Additionally it provides the `i18n.registerTranslation(translationId, defaultText)` and `i18n.registerTranslations({})`
 * functions that can be used to register new translations directly in code.
 *
 * The loader uses acorn to parse the input file and creates the output javascript using escodegen.
 * @param source
 * @param inputSourceMaps
 */
function jsLoader(source, inputSourceMaps) {
    return __awaiter(this, void 0, void 0, function () {
        var loader, callback, _a, code, sourceMaps;
        return __generator(this, function (_b) {
            switch (_b.label) {
                case 0:
                    loader = this;
                    callback = this.async();
                    if (!loader.registerTranslation) {
                        return [2 /*return*/, callback(new Error("The WebpackAngularTranslate plugin is missing. Add the plugin to your webpack configurations 'plugins' section."), source, inputSourceMaps)];
                    }
                    if (loader.cacheable) {
                        loader.cacheable();
                    }
                    if (isExcludedResource(loader.resourcePath)) {
                        return [2 /*return*/, callback(null, source, inputSourceMaps)];
                    }
                    return [4 /*yield*/, extractTranslations(loader, source, inputSourceMaps)];
                case 1:
                    _a = _b.sent(), code = _a.code, sourceMaps = _a.sourceMaps;
                    callback(null, code, sourceMaps);
                    return [2 /*return*/];
            }
        });
    });
}
function extractTranslations(loader, source, sourceMaps) {
    return __awaiter(this, void 0, void 0, function () {
        var options, parserOptions, visitor, sourceAst, transformedAst, code, generateSourceMaps, result, codeWithSourceMap, originalSourceMap;
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0:
                    options = loaderUtils.getOptions(loader) || {};
                    parserOptions = options.parserOptions || {};
                    loader.pruneTranslations(path.relative(loader.context, loader.resourcePath));
                    visitor = translate_visitor_1.default(loader, parserOptions);
                    sourceAst = acorn.parse(source, visitor.options);
                    transformedAst = visitor.visit(sourceAst);
                    code = source;
                    if (!visitor.changedAst) return [3 /*break*/, 3];
                    generateSourceMaps = !!(loader.sourceMap || sourceMaps);
                    result = escodegen.generate(transformedAst, {
                        comment: true,
                        sourceMap: generateSourceMaps ? loader.resourcePath : undefined,
                        sourceMapWithCode: generateSourceMaps,
                        sourceContent: generateSourceMaps ? source : undefined
                    });
                    if (!generateSourceMaps) return [3 /*break*/, 3];
                    codeWithSourceMap = result;
                    code = codeWithSourceMap.code;
                    if (!sourceMaps) return [3 /*break*/, 2];
                    return [4 /*yield*/, new source_map_1.SourceMapConsumer(sourceMaps)];
                case 1:
                    originalSourceMap = _a.sent();
                    codeWithSourceMap.map.applySourceMap(originalSourceMap, loader.resourcePath);
                    _a.label = 2;
                case 2:
                    sourceMaps = codeWithSourceMap.map.toJSON();
                    _a.label = 3;
                case 3: return [2 /*return*/, { code: code, sourceMaps: sourceMaps }];
            }
        });
    });
}
function isExcludedResource(resource) {
    return /angular-translate[\/\\]dist[\/\\]angular-translate\.js$/.test(resource);
}
module.exports = jsLoader;
//# sourceMappingURL=js-loader.js.map